﻿@page
@model IndexModel
@{
    ViewData["Title"] = "Home page";

    // Just put api url here for the sake of simplicity rather than environment
    string apiBaseUrl = "http://localhost:5000";
}

<div class="text-center">
    <h1 class="display-4">TASK 2</h1>
    <h4>This particular Test only display two inputs, country and city for given country</h4>

    <div class="container">
        <div class="row">
            <div class="col-md">
                <select class="js-data-example-ajax" name="country" required onchange="changeCountry()">
                    <option>--Select Country--</option>
                </select>
            </div>
            <div class="col-md">
                <select class="js-data-example-ajax" name="city" required disabled onchange="changeCity()">
                    <option>--Select City--</option>
                </select>
            </div>
        </div>
        <div class="row">
            <div class="col-md">
                <h1 class="my-4">Weather in <span id="cityName"></span></h1>
                <div class="row">
                    <div class="col-md-6">
                        <div class="card">
                            <div class="card-body">
                                <h5 class="card-title">Weather Details</h5>
                                <p><strong>Weather:</strong> <span id="weatherMain"></span></p>
                                <p><strong>Datetime:</strong> <span id="dt"></span></p>
                                <p><strong>Description:</strong> <span id="weatherDescription"></span></p>
                                <p><strong>Temperature Celcius:</strong> <span id="temperatureC"></span> &deg;C</p>
                                <p><strong>Temperature Fahrenheit :</strong> <span id="temperatureF"></span> &deg;F</p>
                                <p><strong>Humidity:</strong> <span id="humidity"></span>%</p>
                                <p><strong>Pressure:</strong> <span id="pressure"></span></p>
                            </div>
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="card">
                            <div class="card-body">
                                <h5 class="card-title">Location Details</h5>
                                <p><strong>Country:</strong> <span id="country"></span></p>
                                <p><strong>Latitude:</strong> <span id="latitude"></span></p>
                                <p><strong>Longitude:</strong> <span id="longitude"></span></p>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@section Scripts
    {
    <script>

        // Country code
        let code;

        //datetime converter from UNIX DT
        function timeConverter(UNIX_timestamp) {
            var a = new Date(UNIX_timestamp * 1000);
            var months = ['Jan', 'Feb', 'Mar', 'Apr', 'May', 'Jun', 'Jul', 'Aug', 'Sep', 'Oct', 'Nov', 'Dec'];
            var year = a.getFullYear();
            var month = months[a.getMonth()];
            var date = a.getDate();
            var hour = a.getHours();
            var min = a.getMinutes();
            var sec = a.getSeconds();
            var time = date + ' ' + month + ' ' + year + ' ' + hour + ':' + min + ':' + sec;
            return time;
        }

        function handleCountry() {
            $("select[name='country']").select2({
                ajax: {
                    url: '@apiBaseUrl/country/query',
                    processResults: function (data) {
                        return {
                            results: $.map(data,
                                function (item) {
                                    console.log(item);
                                    return {
                                        text: item.name,
                                        id: item.code
                                    }
                                }),
                        };
                    },
                    data: function (params) {
                        var query = {
                            search: params.term
                        }

                        return query;
                    }
                }
            });

        }

        function changeCountry() {
            //reset city select2 when new country selected
            $("select[name='city']").prop("disabled", false);
            $("select[name='city']").find('option').remove().end();
            $("select[name='city']").append(new Option("--Select City--", "-")).prop("selected", true);

            code = $("select[name='country']").find(":selected").val();
        }

        function handleCity() {

            $("select[name='city']").select2({
                ajax: {
                    url: '@apiBaseUrl/city/query',
                    processResults: function (data) {
                        return {
                            results: $.map(data,
                                function (item) {
                                    console.log(item);
                                    return {
                                        text: item.name,
                                        id: item.name
                                    }
                                }),
                        };
                    },
                    data: function (params) {
                        var query = {
                            search: params.term,
                            code: code
                        }

                        return query;
                    }
                }
            });
        }

        function loadWeather() {

            var cityName = $("select[name='city']").find(":selected").val();

            var apiUrl = "@apiBaseUrl/weather/data?query=" + cityName;

            $.ajax({
                url: apiUrl,
                type: "GET",
                dataType: "json",
                success: function (data) {
                    // Mengambil data cuaca dari respons JSON

                    $('#dt').text( timeConverter(data.dt));
                    $('#pressure').text(data.main.pressure);
                    $('#weatherMain').text( data.weather[0].main);
                    $('#weatherDescription').text( data.weather[0].description);
                    $('#temperatureC').text( data.main.temp_celcius);
                    $('#temperatureF').text( data.main.temp);
                    $('#humidity').text( data.main.humidity);
                    $('#country').text( data.sys.country);
                    $('#cityName').text( data.name);
                    $('#latitude').text( data.coord.lat);
                    $('#longitude').text( data.coord.lon);
                },
                error: function (xhr, status, error) {
                    console.log("Error: " + error);
                }
            });
        }

        function changeCity() {


            loadWeather();
        }

        

        $(document).ready(function () {

            //init country select2
            handleCountry();

            //init city select2
            handleCity();
        });


    </script>

    }
